package nl.voidcorp.discord.command

import net.dv8tion.jda.api.MessageBuilder
import net.dv8tion.jda.api.entities.*
import net.dv8tion.jda.api.events.message.MessageReceivedEvent


data class CommandMessage(
    private val event: MessageReceivedEvent,
    val params: List<String>,
    val guild: Guild? = if (event.isFromGuild) event.guild else null,
    val message: Message = event.message,
    val user: User = event.author,
    val member: Member? = event.member
) {
    fun reply(message: Message) = event.channel.sendMessage(message).queue()


    fun reply(message: String) =
        MessageBuilder(message).apply { this.replace("@here", "@hеre").replace("@everyone", "@еveryone") }
            .buildAll(MessageBuilder.SplitPolicy.SPACE).forEach { reply(it) }

    fun reply(messageEmbed: MessageEmbed) = event.channel.sendMessage(messageEmbed).queue()

}