package nl.voidcorp.discord.commands.management

import nl.voidcorp.discord.command.*
import nl.voidcorp.discord.storage.GuildStore
import org.springframework.stereotype.Service

@Service
class ModeratorRoleCommand : Command(
    "addmoderatorrole",
    commandLevel = CommandLevel.ADMIN,
    location = CommandSource.GUILD,
    group = CommandGroup.ADMIN,
    aliases = listOf("addmodrole", "amr")

) {

    val regex = "(?:<@&!?)?(\\d+)>?".toRegex()
    override fun handle(event: CommandMessage): CommandResult {
        val guild = repo.findByGuildId(event.guild!!.idLong) ?: GuildStore(event.guild.idLong)
        if (event.params.drop(1).isEmpty()) {
            val roles = guild.moderatorRoles.map { event.guild.getRoleById(it)?.name ?: "Missing role $it" }
                .joinToString(prefix = "Moderator roles: ") { "`$it`" }
            event.reply(roles)
            return CommandResult.SUCCESS
        }
        val l = mutableListOf<String>()
        for (p in event.params.drop(1)) {
            val res = regex.matchEntire(p)
            if (res != null && res.groupValues.size == 2) {
                if (event.guild.getRoleById(res.groupValues[1]) != null) {
                    guild.moderatorRoles.plusAssign(res.groupValues[1].toLong())
                    val role = event.guild.getRoleById(res.groupValues[1])!!
                    l += role.name
                } else event.reply("There is no role with id `${res.groupValues[1]}`")
            }
        }
        repo.save(guild)
        if (l.isNotEmpty())
            event.reply(l.joinToString(prefix = "Added the following roles as moderator roles: ") { "`$it`" })

        return CommandResult.SUCCESS
    }
}