package nl.voidcorp.discord.commands.management

import nl.voidcorp.discord.command.*
import nl.voidcorp.discord.storage.GuildStore
import org.springframework.stereotype.Service

@Service
class RemoveBotChannelCommand : Command(
    "removebotchannel",
    commandLevel = CommandLevel.ADMIN,
    location = CommandSource.GUILD,
    group = CommandGroup.ADMIN,
    aliases = listOf( "rbc")

) {

    val regex = "(?:<#?)?(\\d+)>?".toRegex()
    override fun handle(event: CommandMessage): CommandResult {
        if (event.params.drop(1).isEmpty()) return CommandResult.PARAMETERS
        val guild = repo.findByGuildId(event.guild!!.idLong) ?: GuildStore(event.guild.idLong)
        val l = mutableListOf<String>()
        for (p in event.params.drop(1)) {
            val res = regex.matchEntire(p)
            if (res != null && res.groupValues.size == 2) {
                if (guild.botChannels.contains(res.groupValues[1].toLong())) {
                    guild.botChannels.minusAssign(res.groupValues[1].toLong())
                    val role = event.guild.getTextChannelById(res.groupValues[1])?.id ?: "some channel?"
                    l += role
                } else event.reply("There is no role with id `${res.groupValues[1]}`")
            }
        }
        repo.save(guild)
        if (l.isNotEmpty())
            event.reply(l.joinToString(prefix = "Removed the following channels as bot channels: ") { "<#$it>" })

        return CommandResult.SUCCESS
    }
}