package nl.voidcorp.discord.commands.management

import nl.voidcorp.discord.command.*
import nl.voidcorp.discord.storage.GuildStore
import org.springframework.stereotype.Service

@Service
class SetVerifiedCommand : Command("verify", location = CommandSource.GUILD, commandLevel = CommandLevel.ADMIN, group = CommandGroup.ADMIN) {
    override fun handle(event: CommandMessage): CommandResult {
        val store = repo.findByGuildId(event.guild!!.idLong) ?: GuildStore(event.guild.idLong)
        store.defaultVerified = !store.defaultVerified
        repo.save(store)
        event.reply("Set defaultverified to ${store.defaultVerified}!")
        return CommandResult.SUCCESS
    }
}