package nl.voidcorp.discord.storage

import org.hibernate.annotations.LazyCollection
import org.hibernate.annotations.LazyCollectionOption
import javax.persistence.ElementCollection
import javax.persistence.Entity
import javax.persistence.GeneratedValue
import javax.persistence.Id


@Entity
data class GuildStore(
    var guildId: Long,
    @ElementCollection @LazyCollection(LazyCollectionOption.FALSE) var moderatorRoles: MutableList<Long> = mutableListOf(),
    @ElementCollection @LazyCollection(LazyCollectionOption.FALSE) var adminRoles: MutableList<Long> = mutableListOf(),
    var defaultVerified: Boolean = false,
    @ElementCollection @LazyCollection(LazyCollectionOption.FALSE) var roleMap: MutableMap<String, Long> = mutableMapOf(),
    var prefix: String = "?",
    @ElementCollection @LazyCollection(LazyCollectionOption.FALSE) var botChannels: MutableList<Long> = mutableListOf(),
    @ElementCollection @LazyCollection(LazyCollectionOption.FALSE) var musicChannels: MutableList<Long> = mutableListOf(),
    var loggingChannel: Long? = null,
    @Id
    @GeneratedValue
    var id: Long? = null
)